<template>
  <div id="connect_next_lecture">
    <!-- 사용 시 -->
    <div v-if="isOpen">
      <h3>{{ $t('CONNECT_SECTION.STATUS') }} - {{ $t('CONNECT_SECTION.USE') }}</h3>
      <br />

      <el-table
        :data="resultSessionList"
        :border="true"
        :highlight-current-row="true">
        <el-table-column prop="name" :label="$t('LECTURE_LIST.LECTURE_NAME')"></el-table-column>
        <el-table-column prop="" :label="$t('DASHBOARD.LEVEL_OF_UND')" align="center">
          <template slot-scope="scope">
            <span> {{ scope.row.lower }} 이상 ~ {{ scope.row.upper }} 미만 </span>
          </template>
        </el-table-column>
      </el-table>
      <el-button type="primary" style="float: right;" @click="onClick('DELETE')">{{ $t('TEACHER_CLASS.DEL_CNET_SESN') }}</el-button>

    </div>

    <!-- 미사용 시 -->
    <div v-else>
      <h3>{{ $t('CONNECT_SECTION.STATUS') }} - {{ $t('CONNECT_SECTION.NOT_USE') }}</h3>
      <br />
      <el-switch
        v-model="ifMake"
        :inactive-text="$t('CONNECT_SECTION.NOT_USE')"
        :active-text="$t('CONNECT_SECTION.USE')"
        active-color="#13ce66"
        inactive-color="#ff4949"/>

      <div v-if="ifMake">
        <div>
          <el-table
            :data="sessionList"
            :border="true"
            style="margin-top: 10px;"
            :highlight-current-row="true"
            @selection-change="handleSelectionChange"
            :empty-text="$t('TEACHER_CLASS.NO_SESSION')"
          >
            <el-table-column ref="multipleTable" type="selection" align="center"></el-table-column>
            <el-table-column label="#" min-width="10px;" align="center">
              <template slot-scope="scope">
                {{ scope.$index + 1 }}
              </template>
            </el-table-column>
            <el-table-column prop="name" :label="$t('LECTURE_LIST.LECTURE_NAME')"></el-table-column>
          </el-table>
          <div class="selection_btns">
            <el-button type="primary" @click="selection('accept')" class="accept-btn">{{ $t('TEACHER_CLASS.CONN_SESSION') }}</el-button>
          </div>
        </div>
      </div>
      <el-dialog :visible.sync="conditionVisible" width="60%">
        <el-table
          :data="selectSessionList"
          :border="true"
          :highlight-current-row="true"
          :key="refreshCount">
          <el-table-column label="#" min-width="10px;" align="center">
            <template slot-scope="scope">
              {{ scope.$index + 1 }}
            </template>
          </el-table-column>
          <el-table-column prop="name" :label="$t('LECTURE_LIST.LECTURE_NAME')" align="center"></el-table-column>
          <el-table-column prop="" :label="$t('DASHBOARD.LEVEL_OF_UND')" min-width="40px;" align="center">
            <template slot-scope="scope">
              <el-input v-model="scope.row.lower" style="width: 80px;"></el-input>
              <span> 이상 ~  </span>
              <el-input v-model="scope.row.upper" style="width: 80px;"></el-input>
              <span> 미만 </span>
            </template>
          </el-table-column>
        </el-table>
        <div class="selection_btns">
          <el-button type="primary" @click="onClick('CONNECT')">{{ $t('TEACHER_CLASS.CONN_CONFIRM') }}</el-button>
          <el-button type="danger" @click="onClick('CANCEL')">{{ $t('TEACHER_CLASS.CONN_CANCEL') }}</el-button>
        </div>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters, mapMutations } from 'vuex';
import classService from '../../services/classService';
import lectureService from '../../services/lectureService';


export default {
  name: 'ConnectNextLecture',
  async mounted() {
    const vm = this;
    
    const classes = await classService.getClass({ id: vm.classId });
    const conn_sess = await lectureService.getConnectSession({ id: vm.lectureId });
    const conn_sess_class = await lectureService.getConnectSessionClass({ id: vm.classId });

    vm.sessionList = [];
    classes.data.lectures.forEach((x) => {
      x.valid = true;
    });
    classes.data.lectures.forEach(async (x) => {
      if (conn_sess_class.data.success) {
        conn_sess_class.data.session_list.forEach(async (y) => {
          if (y.source === x.lecture_id) {
            x.valid = false;
          }
        });
        if (x.valid === true) {
          conn_sess_class.data.session_list.forEach(async (y) => {
            if (y.target === x.lecture_id) {
              x.valid = false;
            }
          });
        }
      }
    });
    classes.data.lectures.forEach(async (x) => {
      if (conn_sess_class.data.success && x.valid === true && x.lecture_id !== vm.lectureId) {
        const tmp = {
          name: x.name,
          lecture_id: x.lecture_id,
          _lower: null,
          _upper: null,
          get lower() {
            return this._lower;
          },
          set lower(value) {
            const _value = Number(value);
            if (!isNaN(_value)) {
              this._lower = _value;
            } else {
              vm.refreshCount += 1;
            }
          },
          get upper() {
            return this._upper;
          },
          set upper(value) {
            const _value = Number(value);
            if (!isNaN(_value)) {
              this._upper = _value;
            } else {
              vm.refreshCount += 1;
            }
          }
        };
        await vm.sessionList.push(tmp);
      } else if (!conn_sess_class.data.success) {
        if (x.lecture_id !== vm.lectureId) {
          const tmp = {
            name: x.name,
            lecture_id: x.lecture_id,
            _lower: null,
            _upper: null,
            get lower() {
              return this._lower;
            },
            set lower(value) {
              const _value = Number(value);
              if (!isNaN(_value)) {
                this._lower = _value;
              } else {
                vm.refreshCount += 1;
              }
            },
            get upper() {
              return this._upper;
            },
            set upper(value) {
              const _value = Number(value);
              if (!isNaN(_value)) {
                this._upper = _value;
              } else {
                vm.refreshCount += 1;
              }
            }
          };
          await vm.sessionList.push(tmp);
        }        
      }
    });
    
    vm.isOpen = conn_sess.data.success; // 데이터가 있는지 없는지
    if (vm.isOpen) {
      vm.resultSessionList = [];
      conn_sess.data.session_list.forEach(async (x) => {
        const tmp = {};
        tmp.name = x.name;
        tmp.lower = x.condition_lower;
        tmp.upper = x.condition_upper;
        await vm.resultSessionList.push(tmp);
      });
    }
  },
  data() {
    return {
     isOpen: false,
     ifMake: false,
     sessionList: [],
     multipleSelection: [],
     conditionVisible: false,
     selectSessionList: [],
     resultSessionList: [],
     refreshCount: 0
    }
  },
  computed: {
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.classId, 10);
    },
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
  methods: {
    handleSelectionChange(val) {
      const vm = this;
      vm.multipleSelection = val;
    },
    selection(type) {
      const vm = this;
      if (vm.multipleSelection.length === 0) {
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.SEL_ERROR'),
          message: vm.$t('TEACHER_CLASS.SEL_ERROR_MSG_SESSION'),
          duration: 3000,
          type: 'warning',
        })
        return;
      }
      switch (type) {
        case 'accept': {
          vm.$confirm( vm.$t('TEACHER_CLASS.CONNECT_MUL_SESSION', { num: vm.multipleSelection.length }), vm.$t('TEACHER_CLASS.SESSION_CONNECTION'), {
            confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
            cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
            type: 'warning',
          }).then(async () => {
            vm.selectSessionList = [];
            vm.conditionVisible = true;
            vm.sessionList.forEach((x) => {
              vm.multipleSelection.forEach((y) => {
                if(x.lecture_id === y.lecture_id) {
                  vm.selectSessionList.push(y);
                }
              })
            })
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('TEACHER_CLASS.SESSION_CONNECTION'),
              message: vm.$t('TEACHER_CLASS.CANCEL_CONNECT_SESSION'),
              duration: 3000,
              type: 'warning',
            });
          });
          break;
        }
      }
    },
    async onClick(type) {
      const vm = this;
      switch(type) {
        case 'CONNECT': {
          let check = false;
          vm.selectSessionList.forEach(async (x) => {
            if (x.lower === '' || x.upper === '' || parseInt(x.lower, 10) < 0 || parseInt(x.upper, 10) > 100) {
              check = true;
            }
          });
          if (check === false) {
            vm.selectSessionList.forEach(async (x) => {
              const res = await lectureService.postConnectSession({
                classId: vm.classId,
                source: vm.lectureId,
                target: x.lecture_id,
                conditionLower: x.lower,
                conditionUpper: x.upper,
              });
            });
            vm.selectSessionList = [];
            vm.conditionVisible = false;

            vm.isOpen = true;
            vm.resultSessionList = [];
            const res2 = await lectureService.getConnectSession({ id: vm.lectureId });
            res2.data.session_list.forEach(async (x) => {
              const tmp = {};
              tmp.name = x.name;
              tmp.lower = x.condition_lower;
              tmp.upper = x.condition_upper;
              await vm.resultSessionList.push(tmp);
            });
          } else {
            vm.$notify({
              title: vm.$t('TEACHER_CLASS.CONFM_ERROR'),
              message: vm.$t('TEACHER_CLASS.CONFM_ERROR_MSG'),
              duration: 3000,
              type: 'warning',
            });
          }
          break;
        }
        case 'CANCEL': {
          vm.selectSessionList = [];
          vm.conditionVisible = false;
          break;
        }
        case 'DELETE': {
          const res2 = await lectureService.getConnectSession({ id: vm.lectureId });
          res2.data.session_list.forEach(async (x) => {
            let flag = false;
            vm.sessionList.forEach((y) => {
              if (x.target === y.lecture_id) {
                flag = true;
              }
            });
            if (!flag) {
              const tmp = {};
              tmp.name = x.name;
              tmp.lecture_id = x.target;
              tmp.lower = '';
              tmp.upper = '';
              await vm.sessionList.push(tmp);
            }  
          });
          vm.sessionList.sort((a, b) => {
            const aLectureId = Number(a.lecture_id);
            const bLectureId = Number(b.lecture_id);
            return aLectureId - bLectureId;
          });
          const res = await lectureService.deleteConnectSession({ id: vm.lectureId });
          vm.selectSessionList = [];
          vm.isOpen = false;
          break;
        }
        default:  {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.selection_btns {
  margin-top: 10px;
}
</style>